#include "msg_digest.h"

int msg_digest_error = MSG_DIGEST_OK;

int MSG_DIGEST_calcMD5(const char *key, char *msg_digest)
{
	EVP_MD_CTX md_ctx;
	const EVP_MD *md = NULL;
	int md_len, i;
	unsigned char digest[EVP_MAX_MD_SIZE];

	OpenSSL_add_all_digests();

        md = EVP_get_digestbyname(MD5_DIGEST);

	EVP_MD_CTX_init(&md_ctx);
        EVP_DigestInit_ex(&md_ctx, md, NULL);
        EVP_DigestUpdate(&md_ctx, key, strlen(key));
        EVP_DigestFinal_ex(&md_ctx, digest, &md_len);
        EVP_MD_CTX_cleanup(&md_ctx);

	MSG_DIGEST_MD5_toString(digest, md_len, msg_digest);
	
	return md_len * 2 + 1;
}

int MSG_DIGEST_calcMD5_fromFile(FILE *fd, char *msg_digest)
{
	EVP_MD_CTX *md_ctx = NULL;
	int md_len, i, n;
	char key[MSG_DIGEST_READ_LEN];
	unsigned char digest[EVP_MAX_MD_SIZE];
	
	msg_digest_error = MSG_DIGEST_OK;
	if ((md_ctx = MSG_DIGEST_MD5_init()) != NULL) {

		while (!feof(fd)) {
			n = fread(key, sizeof(char), MSG_DIGEST_READ_LEN, fd);
			if (n > 0) {
	        		EVP_DigestUpdate(md_ctx, key, n);

			} else {
				msg_digest_error = MSG_DIGEST_READ_ERROR;
				return msg_digest_error;
			}
		}

        	EVP_DigestFinal_ex(md_ctx, digest, &md_len);
	        EVP_MD_CTX_cleanup(md_ctx);
	
		MSG_DIGEST_MD5_toString(digest, md_len, msg_digest);
	
		return md_len * 2 + 1;
	}

	return msg_digest_error;
}

EVP_MD_CTX *MSG_DIGEST_MD5_init(void)
{
	EVP_MD_CTX *md_ctx = NULL;
	const EVP_MD *md = NULL;

	msg_digest_error = MSG_DIGEST_OK;
	OpenSSL_add_all_digests();

        md = EVP_get_digestbyname(MD5_DIGEST);

	md_ctx = EVP_MD_CTX_create();
	if (md_ctx == NULL) {
		msg_digest_error = MSG_DIGEST_CREATE;
		return NULL;

	} else {
	        EVP_DigestInit_ex(md_ctx, md, NULL);
		return md_ctx;
	}
}

void MSG_DIGEST_MD5_toString(unsigned char *msg_digest, int len, char *str_md5)
{
	int i, j;

	for (i = 0, j = 0; i < len; i++, j += 2) {
		sprintf(str_md5 + j, "%02x", msg_digest[i]);
	}
}

