#ifndef __MSG_DIGEST_H_
#define _MSG_DIGEST_H_

#include <string.h>
#include <openssl/evp.h>

#define MSG_DIGEST_OK		 0
#define MSG_DIGEST_CREATE	-1
#define MSG_DIGEST_READ_ERROR	-2

#define MD5_DIGEST "MD5"
#define MSG_DIGEST_LENGTH (EVP_MAX_MD_SIZE / 2 + 1)
#define MSG_DIGEST_READ_LEN 1024

/**
 * Calculates the message digest of key in a char array
 * that has been pre-allocated.
 *
 * @key: the key on which the MD5 algorithm will be applied
 * @msg_digest: the digested message
 * @returns: the length of msg_digest
 */
int MSG_DIGEST_calcMD5(const char *key, char *msg_digest);

/**
 */
EVP_MD_CTX* MSG_DIGEST_MD5_init(void);

int MSG_DIGEST_calcMD5_fromFile(FILE *fd, char *msg_digest);

void MSG_DIGEST_MD5_toString(unsigned char *msg_digest, int len, char *str_md5);

#endif

