/***************************************************************************
 *   Copyright (C) 2007 by Jan Dzik, Alexios Kotsifakos, Harambos Nikolaou,*
 *   Kastrisios Konstantinos, Giorgos Pletsis, Kandias Miltiadis           *
 *   iam.jss@gmail.com   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#include "scannerdb.h"

int main(int argc, char *argv[]) {
	scannerdb_t *db=NULL;
	int lines=0;
	int columns=0;
	int i=0, j=0;
	
	printf("Hello, world!\n");
	
	if(DB_init()<0)
		fprintf(stderr, "DB_init() error\n");
	
	if(DB_open(&db)<0)
		fprintf(stderr, "DB_open() error\n");
	
	printf("Number of lines: %d\n", lines=DB_get_lines_num(db));
	
	printf("Number of columns: %d\n", columns=DB_get_columns_num(db));
	
	for(i=0; i<lines; ++i, DB_line_next(db)) {
		printf("Line num %d: ", i);
		
		for(j=0; j<columns; ++j)
			printf("[%d]: %s ", j, DB_get_field(db, j));
		
		printf("\n");
	}
	
	if(DB_close(db)<0)
		fprintf(stderr, "DB_close() error\n");
	
	
	return EXIT_SUCCESS;
}
