/***************************************************************************
 *   Copyright (C) 2007 by Jan Dzik, Alexios Kotsifakos, Harambos Nikolaou,*
 *   Kastrisios Konstantinos, Giorgos Pletsis, Kandias Miltiadis           *
 *   iam.jss@gmail.com   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "errorsRQ.h"

char *RQ_PrintError(int errcode)
{
	switch (errcode) {
		case RQ_SCANNER_OPEN:
			fputs("RQ_ERROR: error on opening requests\n", stderr);
			break;
		case RQ_SCANNER_REQUEST:
			fputs("RQ_ERROR: error on serving request\n", stderr);
			break;
		case RQ_SCANNER_CLOSE:
			fputs("RQ_ERROR: error on closing requests\n", stderr);
			break;
		case RQ_SCANNER_NOMEM:
			fputs("RQ_ERROR: malloc failure\n", stderr);
			break;
		case RQ_SCANNER_OPEN_FILE:
			fputs("RQ_ERROR: error opening file\n", stderr);
			break;
		case RQ_SCANNER_CURL_INIT:
			fputs("RQ_ERROR: error at liburl\n", stderr);
			break;
		case RQ_SCANNER_OUT_OF_BOUNDS:
			fputs("RQ_ERROR: out of bounds access attempt\n", stderr);
			break;
		case RQ_SCANNER_DB_ERROR:
			fputs("RQ_ERROR: error at DB layer\n", stderr);
			break;
	}
	return NULL;
}
