/***************************************************************************
 *   Copyright (C) 2007 by Jan Dzik, Alexios Kotsifakos, Harambos Nikolaou,*
 *   Kastrisios Konstantinos, Giorgos Pletsis, Kandias Miltiadis           *
 *   iam.jss@gmail.com   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ERRORSRQ_H
#define ERRORSRQ_H
#include <stdio.h>

/* define error codes */
#define RQ_SCANNER_OK 0			/* all OK */
#define RQ_SCANNER_OPEN -1		/* error on opening requests */
#define RQ_SCANNER_REQUEST -2		/* error on serving request */
#define RQ_SCANNER_CLOSE -3		/* error on closing requests */
#define RQ_SCANNER_NOMEM -4		/* malloc failure */
#define RQ_SCANNER_OPEN_FILE -5		/* error opening file */
#define RQ_SCANNER_CURL_INIT -6		/* error at liburl */
#define RQ_SCANNER_OUT_OF_BOUNDS -7	/* out of bounds access attempt */
#define RQ_SCANNER_EOR -8		/* end of requests */
#define RQ_SCANNER_DB_ERROR -9		/* error at DB layer */




/* error handling routines */

/* return a statically allocated error string for an error code */
char *RQ_PrintError(int errcode);

#endif
